unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, IPXUnit, WinSock;

type
  TForm1 = class(TForm)
    IPX1: IPX;
    Edit1: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Edit2: TEdit;
    Button1: TButton;
    Memo1: TMemo;
    Edit3: TEdit;
    Button2: TButton;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Edit4: TEdit;
    CheckBox3: TCheckBox;
    CheckBox1: TCheckBox;
    CheckBox4: TCheckBox;
    Label6: TLabel;
    Edit5: TEdit;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure CheckBox3Click(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure IPX1ReceiveData(Sender: TObject; Buffer: PChar;
      BufferLength: Integer; SockAddr: TSockAddrIPX; SockAddrLen: Integer);
    procedure CheckBox4Click(Sender: TObject);
    procedure Edit5Exit(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.Button1Click(Sender: TObject);
begin
     if Button1.Caption = 'Stop' then
     begin
          try
             IPX1.Close
          except
                on E : ESocketError do
                   ShowMessage( 'Close error:'+E.Message )
          end;

          Button1.Caption := 'Start';
          Exit
     end;

     if (Edit1.Text = '') or (Edit2.Text = '') then
     begin
          ShowMessage( 'Lost address information' );
          Exit
     end;

     IPX1.RemoteNetworkNumber := Edit1.Text;
     IPX1.RemoteNodeNumber := Edit2.Text;

     Edit1.Text := IPX1.RemoteNetworkNumber;
     Edit2.Text := IPX1.RemoteNodeNumber;

     try
        IPX1.Open;
        Label3.Caption := IPX1.LocalNetworkNumber;
        Label4.Caption := IPX1.LocalNodeNumber
     except
           on E : ESocketError do
           begin
                ShowMessage( 'Open error:' + E.Message );
                Exit
           end
     end;

     Memo1.Clear;
     Button1.Caption := 'Stop'
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
     try
        IPX1.Send( PChar(Edit3.Text), Length(Edit3.Text) )
     except
           on E : ESocketError do
              ShowMessage( 'Send error:'+ E.Message )
     end
end;

procedure abcdefg;
begin
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
     if Button1.Caption = 'Stop' then
        Button1Click(Sender)
end;

procedure TForm1.CheckBox3Click(Sender: TObject);
begin
     if Edit4.Text <> '' then
     begin
          try
             IPX1.PacketTypeFilter := StrToInt( Edit4.Text )
          except
                on EConvertError do
                   ShowMessage( 'bad filter type value' );
          end;
          IPX1.PacketTypeFiltered := CheckBox3.Checked
     end
end;

procedure TForm1.CheckBox1Click(Sender: TObject);
begin
     IPX1.AllowSendBroadcast := CheckBox1.Checked
end;

procedure TForm1.IPX1ReceiveData(Sender: TObject; Buffer: PChar;
  BufferLength: Integer; SockAddr: TSockAddrIPX; SockAddrLen: Integer);
var
   s : String;
   i : Integer;
begin
     s := '['+IntToStr( BufferLength ) + ']';

     for i := 0 to BufferLength-1 do
         s := s + IntToHex( Ord(Buffer[i]), 2 )+ ' ';
     s := s + '   (from):';
     for i := 0 to 5 do
         s := s + IntToHex( SockAddr.sa_nodenum[i], 2 );
     Memo1.Lines.Add( s )
end;

procedure TForm1.CheckBox4Click(Sender: TObject);
begin
     IPX1.ReceiveHeader := CheckBox4.Checked
end;

procedure TForm1.Edit5Exit(Sender: TObject);
begin
     try
        IPX1.SendPacketType := StrToInt( Edit5.Text )
     except
           on EConvertError do
           begin
                ShowMessage( 'bad send packet type value' );
                Exit
           end
     end
end;

end.

